#include "fsbday.h"
#include "task.h"

class Load : public FSBdayTask <PipelineTask<Part*> >
{
    public:

    void do_job(int level, int tid)
    {
        int i;

        Part *part;

        AleSystem<ale_t, part_t> *alesys;
       
        alesys = new AleSystem<ale_t, part_t>(NPARTS, aledev, false, level, 
                this->getArgv()->get_list0(level, rank) + tid);

        INFO_DEBUG(VERBOSITY > 0,"Number of elements in my list 0: %lu  level: %u\n", 
                    alesys->get_list_size(), level);

        for (i = 0; i < NPARTS; i++)
        {
            part = getSource()->get();
            part->nelems = alesys->read_part(i, part->data);
            getSink()->put(part);
        }

        delete alesys;
     }
};


