#include <inttypes.h>

class Argv
{
  public:
    unsigned int startlevel;
    unsigned int startlist;
    unsigned int startnlists;
#ifdef FINALIZE
    uint64_t cmp;
    uint64_t remaining;
    uint64_t part;
    uint64_t node;
#endif
    bool persist;
    uint8_t *clamp; // pointer to array of length nlists containing clamping values, if startlevel == 0, may be NULL otherwise

    Argv();

    unsigned int get_nlists(int level)const;

    unsigned int get_list0(int level, int rank)const;
    
#ifdef FINALIZE
    uint64_t get_cmp();

    uint64_t get_remaining();
    
    uint64_t get_part();
    
    uint64_t get_node();
#endif

    bool is_final_level(int level);


};


